Attribute VB_Name = "getCtrlImage"
Option Explicit

Public Declare Sub keybd_event Lib "user32" (ByVal bVk As Byte, ByVal bScan As Byte, ByVal dwFlags As Long, ByVal dwExtraInfo As Long)
Public Const VK_MENU = &H12
Public Const VK_SNAPSHOT = &H2C
Public Const KEYEVENTF_KEYUP = &H2

Public Declare Function MapVirtualKey Lib "user32" Alias "MapVirtualKeyA" (ByVal wCode As Long, ByVal wMapType As Long) As Long

' Offset from corner of border to usable form area.
Public m_XOffset As Integer
Public m_YOffset As Integer
Public Type POINTAPI
    X As Long
    Y As Long
End Type
Public Declare Function ClientToScreen Lib "user32" (ByVal hwnd As Long, lpPoint As POINTAPI) As Long
Public Declare Function ScreenToClient Lib "user32" (ByVal hwnd As Long, lpPoint As POINTAPI) As Long
' Get the offset from the corner of the border.
Public Sub GetFormOffset()
    With Form1
        Dim pt As POINTAPI

        pt.X = 0
        pt.Y = 0
        ClientToScreen .picResult.hwnd, pt

        m_XOffset = pt.X - .ScaleX(.Left, vbTwips, vbPixels)
        m_YOffset = pt.Y - .ScaleY(.Top, vbTwips, vbPixels)
    End With
End Sub
' Copythe form's image into picHidden.
Public Function GetFormPicture()
    With Form1
        #Const WINDOWS_VERSION = "Windows2000"

        Dim alt_key As Long

        ' Capture an image of the form in the clipboard.
        ' Press Alt.
        alt_key = MapVirtualKey(VK_MENU, 0)
        keybd_event VK_MENU, alt_key, 0, 0
        DoEvents

        ' Press Print Scrn.
        #If WINDOWS_VERSION = "Windows2000" Then
            keybd_event VK_SNAPSHOT, 0, 0, 0
        #Else
            keybd_event VK_SNAPSHOT, 1, 0, 0
        #End If
        DoEvents

        ' Release Alt.
        keybd_event VK_MENU, alt_key, KEYEVENTF_KEYUP, 0
        DoEvents

        ' Make picHidden big enough.
        .picHidden.BorderStyle = vbBSNone
        .picHidden.Width = .Width
        .picHidden.Height = .Height

        ' Paste the image into picHidden.
        .picHidden.Picture = Clipboard.GetData(vbCFBitmap)
    End With
End Function

' Copy the image of this control onto the
' destination PictureBox.
Public Sub CopyControlImage(ByVal destination As PictureBox, ByVal target As Control)

    destination.Width = target.Width + destination.Width - destination.ScaleWidth
    destination.Height = target.Height + destination.Height - destination.ScaleHeight

    destination.PaintPicture _
            Form1.picHidden.Picture, 0, 0, _
            target.Width, target.Height, _
            target.Left + m_XOffset, target.Top + m_YOffset, _
            target.Width, target.Height
    destination.Picture = destination.Image

End Sub

Sub GetPictures()
    ' Copy the form's image into picHidden.
    With Form1
        GetFormPicture

        ' Get the offset from our border to the form area.
        GetFormOffset

        ' Clip out the control images.
        CopyControlImage .picResult, .MSChart1

    End With
End Sub

